# coding: utf-8

"""
    LUXSCI

    For a technical overview, see [LuxSci API Mechanics Guide](/rest-api/mechanics.html)  Return to [The API Guide](/rest-api.html)  # noqa: E501

    OpenAPI spec version: v2024.1.2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from luxsci.api_client import ApiClient


class UserReportsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_email_feed_back_loops_report_user(self, username, **kwargs):  # noqa: E501
        """get_email_feed_back_loops_report_user  # noqa: E501

        This report allows to see what messages that `username` havs sent successfully that have been “marked as spam” by recipients and this information has come back to LuxSci via one of our feed-back loops.  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#fbl). {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_feed_back_loops_report_user(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str _from: String Case-insensitive substring search of the message “From” email address
        :param str subject: String Case-insensitive substring search of the message subject (in UTF-8).
        :param str to: String. Case-insensitive substring search of all recipient email addresses.
        :param int user_id: Integer Restrict the report to the user with this specific User ID number.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_email_feed_back_loops_report_user_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_email_feed_back_loops_report_user_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_email_feed_back_loops_report_user_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_email_feed_back_loops_report_user  # noqa: E501

        This report allows to see what messages that `username` havs sent successfully that have been “marked as spam” by recipients and this information has come back to LuxSci via one of our feed-back loops.  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#fbl). {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_feed_back_loops_report_user_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str _from: String Case-insensitive substring search of the message “From” email address
        :param str subject: String Case-insensitive substring search of the message subject (in UTF-8).
        :param str to: String. Case-insensitive substring search of all recipient email addresses.
        :param int user_id: Integer Restrict the report to the user with this specific User ID number.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', '_from', 'subject', 'to', 'user_id', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_email_feed_back_loops_report_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_email_feed_back_loops_report_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'to' in params:
            query_params.append(('to', params['to']))  # noqa: E501
        if 'user_id' in params:
            query_params.append(('user_id', params['user_id']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/report/email/fbl', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_email_feed_back_loops_summary_report_user(self, username, **kwargs):  # noqa: E501
        """get_email_feed_back_loops_summary_report_user  # noqa: E501

        This report allows to see how many messages have been marked as spam.  The date of the compliant is used for date filters. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#fbl_count). {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_feed_back_loops_summary_report_user(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str filter1: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter2: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter3: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str _from: String Case-insensitive substring search of the message “From” email address
        :param str subject: String Case-insensitive substring search of the message subject (in UTF-8).
        :param str to: String. Case-insensitive substring search of all recipient email addresses.
        :param int user_id: Integer Restrict the report to the user with this specific User ID number.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_email_feed_back_loops_summary_report_user_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_email_feed_back_loops_summary_report_user_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_email_feed_back_loops_summary_report_user_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_email_feed_back_loops_summary_report_user  # noqa: E501

        This report allows to see how many messages have been marked as spam.  The date of the compliant is used for date filters. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#fbl_count). {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_feed_back_loops_summary_report_user_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str filter1: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter2: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter3: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str _from: String Case-insensitive substring search of the message “From” email address
        :param str subject: String Case-insensitive substring search of the message subject (in UTF-8).
        :param str to: String. Case-insensitive substring search of all recipient email addresses.
        :param int user_id: Integer Restrict the report to the user with this specific User ID number.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', 'filter1', 'filter2', 'filter3', '_from', 'subject', 'to', 'user_id', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_email_feed_back_loops_summary_report_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_email_feed_back_loops_summary_report_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if 'filter1' in params:
            query_params.append(('filter1', params['filter1']))  # noqa: E501
        if 'filter2' in params:
            query_params.append(('filter2', params['filter2']))  # noqa: E501
        if 'filter3' in params:
            query_params.append(('filter3', params['filter3']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'to' in params:
            query_params.append(('to', params['to']))  # noqa: E501
        if 'user_id' in params:
            query_params.append(('user_id', params['user_id']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/report/email/fbl_count', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_email_smtp_click_report_user(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_click_report_user  # noqa: E501

        This report allows you to query on the “URL click” events (or lack thereof) for email messages sent via SMTP by `username` that have email click tracking enabled. Using this command, it is possible to get a report of all individual clicks or to get reports about messages that have not yet been clicked on or for which click tracking was not enabled. See the query parameters for more detail.  *Note that if you are using LuxSci Secure Marketing v2 to send your email messages, then normal LuxSci click and open reporting is disabled (and you will not see click and open data in this report). The LuxSci Secure Marketing v2 platform his its own click and open tracking and reporting system and you should look in that interface for reports.*  See also [API Reporting Basics](/rest-api/reporting.html)  and [report header columns in the response](/rest-api/report-responses.html#click).  Dates, for the purposes of narrowing results, refer to the date the message was sent. This corresponds to the `date_sent` output field. However, if you set the `click_date` input parameter to true, then the `click_date` field will be used for date selections.  {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_click_report_user(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param int clicked: If specified, the results are restricted as follows:<br>clicked < 0 – select messages where click tracking was not enabled.<br>clicked = 0 – select messages where click tracking was enabled, but where no URLs have yet been clicked by the recipient.<br>clicked > 0 – select messages where one or more URLs have been clicked by the recipient. When “clicked” is positive, you will get one row back for each click; so,<i>you can get multiple rows per message</i>.<br><br>If a value for “clicked” is not specified, a value of “1” will be assumed.
        :param str click_date: If true, the ”click_date” field will be used for all date selections. If false or not specified, the sent date (“date_sent”) will be used.
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled, and which have been opened at least once. 
        :param str sendmail_id: String. Return only the messages with the specified sendmail_id
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param str status: Values:<br><b>delivered</b> – Accepted by the recipient’s email servers and presumed delivered. If bounce processing is enabled, then this status could change later to ba_soft_fail or ba_hard_fail.<br><b>perm_fail</b> – Messages that have permanently failed to be delivered to the recipient’s servers. If bounce processing is on, this status could change shortly to ba_soft_fail, depending on the nature of the failure message.<br><b>lost</b> – Messages where the tracking was lost and it is unclear if it was delivered or lost from the queue.<br><b>queued</b> – Message is in the email server queue still waiting to be delivered to the recipient.<br><b>not_queued</b> -- all statuses except \"queued\". <br><b>ba_soft_fail</b> – Soft failure bounces received (when talking to the recipient’s servers or after successful delivery to the recipient’s servers).<br><b>ba_hard_fail</b> – Hard failure bounces received after successful delivery to the recipient’s servers,<br><b>any_hard_fail</b> – Results for ba_hard_fail OR perm_fail. I.e., all hard/permanent failures.
        :param str subject: Case-insensitive substring search of the message subject (in UTF8).
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param int template_id: Optional template ID to select results only for those messages sent using the specified template.  A value of 0 selects all.
        :param str user_id: Restrict the report to the user with this specific User ID number
        :param str url: Substring match on the URL clicked.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_email_smtp_click_report_user_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_email_smtp_click_report_user_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_email_smtp_click_report_user_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_click_report_user  # noqa: E501

        This report allows you to query on the “URL click” events (or lack thereof) for email messages sent via SMTP by `username` that have email click tracking enabled. Using this command, it is possible to get a report of all individual clicks or to get reports about messages that have not yet been clicked on or for which click tracking was not enabled. See the query parameters for more detail.  *Note that if you are using LuxSci Secure Marketing v2 to send your email messages, then normal LuxSci click and open reporting is disabled (and you will not see click and open data in this report). The LuxSci Secure Marketing v2 platform his its own click and open tracking and reporting system and you should look in that interface for reports.*  See also [API Reporting Basics](/rest-api/reporting.html)  and [report header columns in the response](/rest-api/report-responses.html#click).  Dates, for the purposes of narrowing results, refer to the date the message was sent. This corresponds to the `date_sent` output field. However, if you set the `click_date` input parameter to true, then the `click_date` field will be used for date selections.  {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_click_report_user_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param int clicked: If specified, the results are restricted as follows:<br>clicked < 0 – select messages where click tracking was not enabled.<br>clicked = 0 – select messages where click tracking was enabled, but where no URLs have yet been clicked by the recipient.<br>clicked > 0 – select messages where one or more URLs have been clicked by the recipient. When “clicked” is positive, you will get one row back for each click; so,<i>you can get multiple rows per message</i>.<br><br>If a value for “clicked” is not specified, a value of “1” will be assumed.
        :param str click_date: If true, the ”click_date” field will be used for all date selections. If false or not specified, the sent date (“date_sent”) will be used.
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled, and which have been opened at least once. 
        :param str sendmail_id: String. Return only the messages with the specified sendmail_id
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param str status: Values:<br><b>delivered</b> – Accepted by the recipient’s email servers and presumed delivered. If bounce processing is enabled, then this status could change later to ba_soft_fail or ba_hard_fail.<br><b>perm_fail</b> – Messages that have permanently failed to be delivered to the recipient’s servers. If bounce processing is on, this status could change shortly to ba_soft_fail, depending on the nature of the failure message.<br><b>lost</b> – Messages where the tracking was lost and it is unclear if it was delivered or lost from the queue.<br><b>queued</b> – Message is in the email server queue still waiting to be delivered to the recipient.<br><b>not_queued</b> -- all statuses except \"queued\". <br><b>ba_soft_fail</b> – Soft failure bounces received (when talking to the recipient’s servers or after successful delivery to the recipient’s servers).<br><b>ba_hard_fail</b> – Hard failure bounces received after successful delivery to the recipient’s servers,<br><b>any_hard_fail</b> – Results for ba_hard_fail OR perm_fail. I.e., all hard/permanent failures.
        :param str subject: Case-insensitive substring search of the message subject (in UTF8).
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param int template_id: Optional template ID to select results only for those messages sent using the specified template.  A value of 0 selects all.
        :param str user_id: Restrict the report to the user with this specific User ID number
        :param str url: Substring match on the URL clicked.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', '_from', 'clicked', 'click_date', 'header1', 'header1_operator', 'header1_value', 'header2', 'header2_operator', 'header2_value', 'header3', 'header3_operator', 'header3_value', 'opened', 'sendmail_id', 'sendmail_ids', 'status', 'subject', 'to', 'tracked_headers', 'template_id', 'user_id', 'url', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_email_smtp_click_report_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_email_smtp_click_report_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'clicked' in params:
            query_params.append(('clicked', params['clicked']))  # noqa: E501
        if 'click_date' in params:
            query_params.append(('click_date', params['click_date']))  # noqa: E501
        if 'header1' in params:
            query_params.append(('header1', params['header1']))  # noqa: E501
        if 'header1_operator' in params:
            query_params.append(('header1_operator', params['header1_operator']))  # noqa: E501
        if 'header1_value' in params:
            query_params.append(('header1_value', params['header1_value']))  # noqa: E501
        if 'header2' in params:
            query_params.append(('header2', params['header2']))  # noqa: E501
        if 'header2_operator' in params:
            query_params.append(('header2_operator', params['header2_operator']))  # noqa: E501
        if 'header2_value' in params:
            query_params.append(('header2_value', params['header2_value']))  # noqa: E501
        if 'header3' in params:
            query_params.append(('header3', params['header3']))  # noqa: E501
        if 'header3_operator' in params:
            query_params.append(('header3_operator', params['header3_operator']))  # noqa: E501
        if 'header3_value' in params:
            query_params.append(('header3_value', params['header3_value']))  # noqa: E501
        if 'opened' in params:
            query_params.append(('opened', params['opened']))  # noqa: E501
        if 'sendmail_id' in params:
            query_params.append(('sendmail_id', params['sendmail_id']))  # noqa: E501
        if 'sendmail_ids' in params:
            query_params.append(('sendmail_ids', params['sendmail_ids']))  # noqa: E501
        if 'status' in params:
            query_params.append(('status', params['status']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'to' in params:
            query_params.append(('to', params['to']))  # noqa: E501
        if 'tracked_headers' in params:
            query_params.append(('tracked_headers', params['tracked_headers']))  # noqa: E501
        if 'template_id' in params:
            query_params.append(('template_id', params['template_id']))  # noqa: E501
        if 'user_id' in params:
            query_params.append(('user_id', params['user_id']))  # noqa: E501
        if 'url' in params:
            query_params.append(('url', params['url']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/report/email/smtp/clicks', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_email_smtp_click_summary_report_user(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_click_summary_report_user  # noqa: E501

        This report allows you to query the number of clicks on tracked links during the specified date period. *Note that if you are using LuxSci Secure Marketing v2 to send your email messages, then normal LuxSci click and open reporting is disabled (and you will not see click and open data in this report). The LuxSci Secure Marketing v2 platform his its own click and open tracking and reporting system and you should look in that interface for reports.* See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#clicks_count). Dates, for the purposes of narrowing results, refer to the date the link was clicked on.  {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_click_summary_report_user(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str filter1: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter2: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter3: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param str subject: Case-insensitive substring search of the message subject (in UTF8).
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param int template_id: Optional template ID to select results only for those messages sent using the specified template.  A value of 0 selects all.
        :param str user_id: Restrict the report to the user with this specific User ID number
        :param str url: Substring match on the URL clicked.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_email_smtp_click_summary_report_user_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_email_smtp_click_summary_report_user_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_email_smtp_click_summary_report_user_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_click_summary_report_user  # noqa: E501

        This report allows you to query the number of clicks on tracked links during the specified date period. *Note that if you are using LuxSci Secure Marketing v2 to send your email messages, then normal LuxSci click and open reporting is disabled (and you will not see click and open data in this report). The LuxSci Secure Marketing v2 platform his its own click and open tracking and reporting system and you should look in that interface for reports.* See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#clicks_count). Dates, for the purposes of narrowing results, refer to the date the link was clicked on.  {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_click_summary_report_user_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str filter1: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter2: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter3: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param str subject: Case-insensitive substring search of the message subject (in UTF8).
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param int template_id: Optional template ID to select results only for those messages sent using the specified template.  A value of 0 selects all.
        :param str user_id: Restrict the report to the user with this specific User ID number
        :param str url: Substring match on the URL clicked.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', 'filter1', 'filter2', 'filter3', '_from', 'header1', 'header1_operator', 'header1_value', 'header2', 'header2_operator', 'header2_value', 'header3', 'header3_operator', 'header3_value', 'subject', 'tracked_headers', 'template_id', 'user_id', 'url', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_email_smtp_click_summary_report_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_email_smtp_click_summary_report_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if 'filter1' in params:
            query_params.append(('filter1', params['filter1']))  # noqa: E501
        if 'filter2' in params:
            query_params.append(('filter2', params['filter2']))  # noqa: E501
        if 'filter3' in params:
            query_params.append(('filter3', params['filter3']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'header1' in params:
            query_params.append(('header1', params['header1']))  # noqa: E501
        if 'header1_operator' in params:
            query_params.append(('header1_operator', params['header1_operator']))  # noqa: E501
        if 'header1_value' in params:
            query_params.append(('header1_value', params['header1_value']))  # noqa: E501
        if 'header2' in params:
            query_params.append(('header2', params['header2']))  # noqa: E501
        if 'header2_operator' in params:
            query_params.append(('header2_operator', params['header2_operator']))  # noqa: E501
        if 'header2_value' in params:
            query_params.append(('header2_value', params['header2_value']))  # noqa: E501
        if 'header3' in params:
            query_params.append(('header3', params['header3']))  # noqa: E501
        if 'header3_operator' in params:
            query_params.append(('header3_operator', params['header3_operator']))  # noqa: E501
        if 'header3_value' in params:
            query_params.append(('header3_value', params['header3_value']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'tracked_headers' in params:
            query_params.append(('tracked_headers', params['tracked_headers']))  # noqa: E501
        if 'template_id' in params:
            query_params.append(('template_id', params['template_id']))  # noqa: E501
        if 'user_id' in params:
            query_params.append(('user_id', params['user_id']))  # noqa: E501
        if 'url' in params:
            query_params.append(('url', params['url']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/report/email/smtp/clicks_count', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_email_smtp_delivery_status_report_user(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_delivery_status_report_user  # noqa: E501

        This report allows you to see how each SMTP message sent by `username` was sent to each recipient and what the delivery status is for each of these recipients. Note that delivery status changes over time as messages progress to the recipient’s servers and as bounce messages are sent back and processed. As the delivery status changes, the `last_update` date is also updated.  See also [API Reporting Basics](/rest-api/reporting.html)  and [report header columns in the response](/rest-api/report-responses.html#delivery).  Dates, for the purposes of narrowing results, refer to the *date the message delivery status was last updated*. This corresponds to the `last_update` output field.  This can be changed to the date the message was sent using the \"sent_date\" parameter. {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_delivery_status_report_user(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param int clicked: Integer. If specified, the results are restricted as follows:<br>clicked < 0 – select messages where URL click tracking was not enabled.<br>clicked = 0 – select messages where URL click tracking was enabled, but where there have as yet been no clicks on any clinks in the messages.<br>clicked > 0 – select messages where URL click tracking was enabled and where there have been N or more clicks on links in the same message to the same recipient. N, in this case, is the number that you have specified as the value of the “clicked” parameter. I.e., using a value of “1” matches all messages that have had a link clicked on.
        :param str _from: String. Case-insensitive substring search of the message “From” email Address
        :param str ip: String. Case-insensitive substring search of the sender IP address (for SMTP reports only).
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: Integer. If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled and which have been opened at least N times. N, in this case, is the number that you have specified as the value of the “opened” parameter. I.e., using a value of “1” matches all messages that have been opened.
        :param str secureline: Enum. Value:<br>u – Message to this recipient did not use SecureLine (or Opt Out was used)<br>e – Message did use SecureLine<br>-2 – SecureLine was not used due to Opt Out being selected<br>-1 – SecureLine usage not recorded for some reason<br>1 – SecureLine:PGP was used<br>2 – SecureLine:S/MIME was used<br>3 – SecureLine:Escrow was used<br>4 – SecureLine:TLS was used
        :param str sendmail_id: String. Return only the messages with the specified sendmail_id
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param int sent_date: If set to true (i.e., 1), the email message sent date will be used for date/time selections, instead of the date of the last update of the delivery status.
        :param int spam: Enum. Value:<br>0 – Message was not marked as spam by a recipient and returned in a Feed Back Loop.<br>1 – Message was marked as spam by a recipient and returned in a Feed Back Loop
        :param int unsubscribed: Enum. Value: 0 – The recipient did not unsubscribe based on this email message. 1 – The recipient did unsubscribe based on this email message.
        :param str smtp_code: String. 1-3 characters.  Substring match to the beginning of the smtp_code field.  E.g., 5 matches all codes starting with 5.
        :param int tls: Enum. Value:<br>0 – TLS was NOT used in the successful delivery of this message to the recipient server<br>1 – TLS was used in the successful delivery of this message to the recipient server.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param int template_id: Optional template ID to select results only for those messages sent using the specified template.  A value of 0 selects all.
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param int user_id: Integer. Restrict the report to the user with this specific User ID number
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_email_smtp_delivery_status_report_user_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_email_smtp_delivery_status_report_user_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_email_smtp_delivery_status_report_user_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_delivery_status_report_user  # noqa: E501

        This report allows you to see how each SMTP message sent by `username` was sent to each recipient and what the delivery status is for each of these recipients. Note that delivery status changes over time as messages progress to the recipient’s servers and as bounce messages are sent back and processed. As the delivery status changes, the `last_update` date is also updated.  See also [API Reporting Basics](/rest-api/reporting.html)  and [report header columns in the response](/rest-api/report-responses.html#delivery).  Dates, for the purposes of narrowing results, refer to the *date the message delivery status was last updated*. This corresponds to the `last_update` output field.  This can be changed to the date the message was sent using the \"sent_date\" parameter. {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_delivery_status_report_user_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param int clicked: Integer. If specified, the results are restricted as follows:<br>clicked < 0 – select messages where URL click tracking was not enabled.<br>clicked = 0 – select messages where URL click tracking was enabled, but where there have as yet been no clicks on any clinks in the messages.<br>clicked > 0 – select messages where URL click tracking was enabled and where there have been N or more clicks on links in the same message to the same recipient. N, in this case, is the number that you have specified as the value of the “clicked” parameter. I.e., using a value of “1” matches all messages that have had a link clicked on.
        :param str _from: String. Case-insensitive substring search of the message “From” email Address
        :param str ip: String. Case-insensitive substring search of the sender IP address (for SMTP reports only).
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: Integer. If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled and which have been opened at least N times. N, in this case, is the number that you have specified as the value of the “opened” parameter. I.e., using a value of “1” matches all messages that have been opened.
        :param str secureline: Enum. Value:<br>u – Message to this recipient did not use SecureLine (or Opt Out was used)<br>e – Message did use SecureLine<br>-2 – SecureLine was not used due to Opt Out being selected<br>-1 – SecureLine usage not recorded for some reason<br>1 – SecureLine:PGP was used<br>2 – SecureLine:S/MIME was used<br>3 – SecureLine:Escrow was used<br>4 – SecureLine:TLS was used
        :param str sendmail_id: String. Return only the messages with the specified sendmail_id
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param int sent_date: If set to true (i.e., 1), the email message sent date will be used for date/time selections, instead of the date of the last update of the delivery status.
        :param int spam: Enum. Value:<br>0 – Message was not marked as spam by a recipient and returned in a Feed Back Loop.<br>1 – Message was marked as spam by a recipient and returned in a Feed Back Loop
        :param int unsubscribed: Enum. Value: 0 – The recipient did not unsubscribe based on this email message. 1 – The recipient did unsubscribe based on this email message.
        :param str smtp_code: String. 1-3 characters.  Substring match to the beginning of the smtp_code field.  E.g., 5 matches all codes starting with 5.
        :param int tls: Enum. Value:<br>0 – TLS was NOT used in the successful delivery of this message to the recipient server<br>1 – TLS was used in the successful delivery of this message to the recipient server.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param int template_id: Optional template ID to select results only for those messages sent using the specified template.  A value of 0 selects all.
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param int user_id: Integer. Restrict the report to the user with this specific User ID number
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', 'clicked', '_from', 'ip', 'header1', 'header1_operator', 'header1_value', 'header2', 'header2_operator', 'header2_value', 'header3', 'header3_operator', 'header3_value', 'opened', 'secureline', 'sendmail_id', 'sendmail_ids', 'sent_date', 'spam', 'unsubscribed', 'smtp_code', 'tls', 'tracked_headers', 'template_id', 'to', 'user_id', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_email_smtp_delivery_status_report_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_email_smtp_delivery_status_report_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if 'clicked' in params:
            query_params.append(('clicked', params['clicked']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'ip' in params:
            query_params.append(('ip', params['ip']))  # noqa: E501
        if 'header1' in params:
            query_params.append(('header1', params['header1']))  # noqa: E501
        if 'header1_operator' in params:
            query_params.append(('header1_operator', params['header1_operator']))  # noqa: E501
        if 'header1_value' in params:
            query_params.append(('header1_value', params['header1_value']))  # noqa: E501
        if 'header2' in params:
            query_params.append(('header2', params['header2']))  # noqa: E501
        if 'header2_operator' in params:
            query_params.append(('header2_operator', params['header2_operator']))  # noqa: E501
        if 'header2_value' in params:
            query_params.append(('header2_value', params['header2_value']))  # noqa: E501
        if 'header3' in params:
            query_params.append(('header3', params['header3']))  # noqa: E501
        if 'header3_operator' in params:
            query_params.append(('header3_operator', params['header3_operator']))  # noqa: E501
        if 'header3_value' in params:
            query_params.append(('header3_value', params['header3_value']))  # noqa: E501
        if 'opened' in params:
            query_params.append(('opened', params['opened']))  # noqa: E501
        if 'secureline' in params:
            query_params.append(('secureline', params['secureline']))  # noqa: E501
        if 'sendmail_id' in params:
            query_params.append(('sendmail_id', params['sendmail_id']))  # noqa: E501
        if 'sendmail_ids' in params:
            query_params.append(('sendmail_ids', params['sendmail_ids']))  # noqa: E501
        if 'sent_date' in params:
            query_params.append(('sent_date', params['sent_date']))  # noqa: E501
        if 'spam' in params:
            query_params.append(('spam', params['spam']))  # noqa: E501
        if 'unsubscribed' in params:
            query_params.append(('unsubscribed', params['unsubscribed']))  # noqa: E501
        if 'smtp_code' in params:
            query_params.append(('smtp_code', params['smtp_code']))  # noqa: E501
        if 'tls' in params:
            query_params.append(('tls', params['tls']))  # noqa: E501
        if 'tracked_headers' in params:
            query_params.append(('tracked_headers', params['tracked_headers']))  # noqa: E501
        if 'template_id' in params:
            query_params.append(('template_id', params['template_id']))  # noqa: E501
        if 'to' in params:
            query_params.append(('to', params['to']))  # noqa: E501
        if 'user_id' in params:
            query_params.append(('user_id', params['user_id']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/report/email/smtp/delivery', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_email_smtp_delivery_status_summary_report_user(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_delivery_status_summary_report_user  # noqa: E501

        This report allows you to retrieve a summary of the delivery status (and other statistics) across all messages in a given time range. See also [API Reporting Basics](/rest-api/reporting.html)  and [report header columns in the response](/rest-api/report-responses.html#delivery_count). Dates, for the purposes of narrowing results, refer to the *date the message delivery status was last updated*. This can be changed to the date the message was sent using the \"sent_date\" parameter. {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_delivery_status_summary_report_user(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str filter1: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter2: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter3: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param int clicked: Integer. If specified, the results are restricted as follows:<br>clicked < 0 – select messages where URL click tracking was not enabled.<br>clicked = 0 – select messages where URL click tracking was enabled, but where there have as yet been no clicks on any clinks in the messages.<br>clicked > 0 – select messages where URL click tracking was enabled and where there have been N or more clicks on links in the same message to the same recipient. N, in this case, is the number that you have specified as the value of the “clicked” parameter. I.e., using a value of “1” matches all messages that have had a link clicked on.
        :param str _from: String. Case-insensitive substring search of the message “From” email Address
        :param str ip: String. Case-insensitive substring search of the sender IP address (for SMTP reports only).
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: Integer. If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled and which have been opened at least N times. N, in this case, is the number that you have specified as the value of the “opened” parameter. I.e., using a value of “1” matches all messages that have been opened.
        :param str secureline: Enum. Value:<br>u – Message to this recipient did not use SecureLine (or Opt Out was used)<br>e – Message did use SecureLine<br>-2 – SecureLine was not used due to Opt Out being selected<br>-1 – SecureLine usage not recorded for some reason<br>1 – SecureLine:PGP was used<br>2 – SecureLine:S/MIME was used<br>3 – SecureLine:Escrow was used<br>4 – SecureLine:TLS was used
        :param int sent_date: If set to true (i.e., 1), the email message sent date will be used for date/time selections, instead of the date of the last update of the delivery status.
        :param int queue_age_sec: If provided, then the \"queued\" and \"pct_queued\" results will reflect only those messages that have been not delivered for at least this number of seconds.  I.e., use this to eliminate very recently sent messages from your analysis or how mange messages were queued and not yet delivered.
        :param int unsubscribed: Enum. Value: 0 – The recipient did not unsubscribe based on this email message. 1 – The recipient did unsubscribe based on this email message.
        :param int tls: Enum. Value:<br>0 – TLS was NOT used in the successful delivery of this message to the recipient server<br>1 – TLS was used in the successful delivery of this message to the recipient server.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param int template_id: Optional template ID to select results only for those messages sent using the specified template.  A value of 0 selects all.
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_email_smtp_delivery_status_summary_report_user_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_email_smtp_delivery_status_summary_report_user_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_email_smtp_delivery_status_summary_report_user_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_delivery_status_summary_report_user  # noqa: E501

        This report allows you to retrieve a summary of the delivery status (and other statistics) across all messages in a given time range. See also [API Reporting Basics](/rest-api/reporting.html)  and [report header columns in the response](/rest-api/report-responses.html#delivery_count). Dates, for the purposes of narrowing results, refer to the *date the message delivery status was last updated*. This can be changed to the date the message was sent using the \"sent_date\" parameter. {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_delivery_status_summary_report_user_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str filter1: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter2: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter3: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param int clicked: Integer. If specified, the results are restricted as follows:<br>clicked < 0 – select messages where URL click tracking was not enabled.<br>clicked = 0 – select messages where URL click tracking was enabled, but where there have as yet been no clicks on any clinks in the messages.<br>clicked > 0 – select messages where URL click tracking was enabled and where there have been N or more clicks on links in the same message to the same recipient. N, in this case, is the number that you have specified as the value of the “clicked” parameter. I.e., using a value of “1” matches all messages that have had a link clicked on.
        :param str _from: String. Case-insensitive substring search of the message “From” email Address
        :param str ip: String. Case-insensitive substring search of the sender IP address (for SMTP reports only).
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: Integer. If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled and which have been opened at least N times. N, in this case, is the number that you have specified as the value of the “opened” parameter. I.e., using a value of “1” matches all messages that have been opened.
        :param str secureline: Enum. Value:<br>u – Message to this recipient did not use SecureLine (or Opt Out was used)<br>e – Message did use SecureLine<br>-2 – SecureLine was not used due to Opt Out being selected<br>-1 – SecureLine usage not recorded for some reason<br>1 – SecureLine:PGP was used<br>2 – SecureLine:S/MIME was used<br>3 – SecureLine:Escrow was used<br>4 – SecureLine:TLS was used
        :param int sent_date: If set to true (i.e., 1), the email message sent date will be used for date/time selections, instead of the date of the last update of the delivery status.
        :param int queue_age_sec: If provided, then the \"queued\" and \"pct_queued\" results will reflect only those messages that have been not delivered for at least this number of seconds.  I.e., use this to eliminate very recently sent messages from your analysis or how mange messages were queued and not yet delivered.
        :param int unsubscribed: Enum. Value: 0 – The recipient did not unsubscribe based on this email message. 1 – The recipient did unsubscribe based on this email message.
        :param int tls: Enum. Value:<br>0 – TLS was NOT used in the successful delivery of this message to the recipient server<br>1 – TLS was used in the successful delivery of this message to the recipient server.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param int template_id: Optional template ID to select results only for those messages sent using the specified template.  A value of 0 selects all.
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', 'filter1', 'filter2', 'filter3', 'clicked', '_from', 'ip', 'header1', 'header1_operator', 'header1_value', 'header2', 'header2_operator', 'header2_value', 'header3', 'header3_operator', 'header3_value', 'opened', 'secureline', 'sent_date', 'queue_age_sec', 'unsubscribed', 'tls', 'tracked_headers', 'template_id', 'to', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_email_smtp_delivery_status_summary_report_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_email_smtp_delivery_status_summary_report_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if 'filter1' in params:
            query_params.append(('filter1', params['filter1']))  # noqa: E501
        if 'filter2' in params:
            query_params.append(('filter2', params['filter2']))  # noqa: E501
        if 'filter3' in params:
            query_params.append(('filter3', params['filter3']))  # noqa: E501
        if 'clicked' in params:
            query_params.append(('clicked', params['clicked']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'ip' in params:
            query_params.append(('ip', params['ip']))  # noqa: E501
        if 'header1' in params:
            query_params.append(('header1', params['header1']))  # noqa: E501
        if 'header1_operator' in params:
            query_params.append(('header1_operator', params['header1_operator']))  # noqa: E501
        if 'header1_value' in params:
            query_params.append(('header1_value', params['header1_value']))  # noqa: E501
        if 'header2' in params:
            query_params.append(('header2', params['header2']))  # noqa: E501
        if 'header2_operator' in params:
            query_params.append(('header2_operator', params['header2_operator']))  # noqa: E501
        if 'header2_value' in params:
            query_params.append(('header2_value', params['header2_value']))  # noqa: E501
        if 'header3' in params:
            query_params.append(('header3', params['header3']))  # noqa: E501
        if 'header3_operator' in params:
            query_params.append(('header3_operator', params['header3_operator']))  # noqa: E501
        if 'header3_value' in params:
            query_params.append(('header3_value', params['header3_value']))  # noqa: E501
        if 'opened' in params:
            query_params.append(('opened', params['opened']))  # noqa: E501
        if 'secureline' in params:
            query_params.append(('secureline', params['secureline']))  # noqa: E501
        if 'sent_date' in params:
            query_params.append(('sent_date', params['sent_date']))  # noqa: E501
        if 'queue_age_sec' in params:
            query_params.append(('queue_age_sec', params['queue_age_sec']))  # noqa: E501
        if 'unsubscribed' in params:
            query_params.append(('unsubscribed', params['unsubscribed']))  # noqa: E501
        if 'tls' in params:
            query_params.append(('tls', params['tls']))  # noqa: E501
        if 'tracked_headers' in params:
            query_params.append(('tracked_headers', params['tracked_headers']))  # noqa: E501
        if 'template_id' in params:
            query_params.append(('template_id', params['template_id']))  # noqa: E501
        if 'to' in params:
            query_params.append(('to', params['to']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/report/email/smtp/delivery_count', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_email_smtp_login_failure_report_user(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_login_failure_report_user  # noqa: E501

        This report allows to see all SMTP login failures to the user login `username`, as well as sending errors that resulted from our servers explicitly rejecting your request to send an email message for one reason or another.  See also [API Reporting Basics](/rest-api/reporting.html)  and [report header columns in the response](/rest-api/report-responses.html#smtp_login_fail). {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_login_failure_report_user(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str ip: String. Case-insensitive substring search of the message “IP Address” if the email program or device that made the connection.
        :param str reason: String Case-insensitive substring search of the login failure / reason data.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_email_smtp_login_failure_report_user_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_email_smtp_login_failure_report_user_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_email_smtp_login_failure_report_user_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_login_failure_report_user  # noqa: E501

        This report allows to see all SMTP login failures to the user login `username`, as well as sending errors that resulted from our servers explicitly rejecting your request to send an email message for one reason or another.  See also [API Reporting Basics](/rest-api/reporting.html)  and [report header columns in the response](/rest-api/report-responses.html#smtp_login_fail). {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_login_failure_report_user_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str ip: String. Case-insensitive substring search of the message “IP Address” if the email program or device that made the connection.
        :param str reason: String Case-insensitive substring search of the login failure / reason data.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', 'ip', 'reason', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_email_smtp_login_failure_report_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_email_smtp_login_failure_report_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if 'ip' in params:
            query_params.append(('ip', params['ip']))  # noqa: E501
        if 'reason' in params:
            query_params.append(('Reason', params['reason']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/report/login_fail/smtp', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_email_smtp_open_report_user(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_open_report_user  # noqa: E501

        This report allows you to query on the “opened” events (or lack thereof) for email messages sent via SMTP by `username` that have email open tracking enabled. Using this command, it is possible to get a report of all individual opens for messages or to get reports about messages that have not yet been opened or for which open tracking was not enabled. See the query parameters for more detail.  *Note: if you are using LuxSci Secure Marketing v2 to send your email messages, then normal LuxSci click and open reporting is disabled (and you will not see click and open data in this report). The LuxSci Secure Marketing v2 platform his its own click and open tracking and reporting system and you should look in that interface for reports.*  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#open).  Dates, for the purposes of narrowing results, refer to the date the message was sent. This corresponds to the “date_sent” output field. However, if you set the “open_date” input parameter to true, then the “open_date” field will be used for date selections.  {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_open_report_user(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled and which have been opened at least once. When opened is positive, you will get one row back for each open; so, <i>you can get multiple rows per message</i>.<br><br>If you do not specify a value for “opened”, a value of “1” will be assumed.
        :param bool open_date: If true, the ”open_date” field will be used for all date selections. If false or not specified, the sent date (“date_sent”) will be used.
        :param str sendmail_id: Return only the messages with the specified sendmail_id.
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param str status: Values:<br><b>delivered</b> – Accepted by the recipient’s email servers and presumed delivered. If bounce processing is enabled, then this status could change later to ba_soft_fail or ba_hard_fail.<br><b>perm_fail</b> – Messages that have permanently failed to be delivered to the recipient’s servers. If bounce processing is on, this status could change shortly to ba_soft_fail, depending on the nature of the failure message.<br><b>lost</b> – Messages where the tracking was lost and it is unclear if it was delivered or lost from the queue.<br><b>queued</b> – Message is in the email server queue still waiting to be delivered to the recipient.<br><b>not_queued</b> -- all statuses except \"queued\". <br><b>ba_soft_fail</b> – Soft failure bounces received (when talking to the recipient’s servers or after successful delivery to the recipient’s servers).<br><b>ba_hard_fail</b> – Hard failure bounces received after successful delivery to the recipient’s servers,<br><b>any_hard_fail</b> – Results for ba_hard_fail OR perm_fail. I.e., all hard/permanent failures.
        :param str subject: Case-insensitive substring search of the message subject (in UTF8).
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param int template_id: Optional template ID to select results only for those messages sent using the specified template.  A value of 0 selects all.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_email_smtp_open_report_user_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_email_smtp_open_report_user_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_email_smtp_open_report_user_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_open_report_user  # noqa: E501

        This report allows you to query on the “opened” events (or lack thereof) for email messages sent via SMTP by `username` that have email open tracking enabled. Using this command, it is possible to get a report of all individual opens for messages or to get reports about messages that have not yet been opened or for which open tracking was not enabled. See the query parameters for more detail.  *Note: if you are using LuxSci Secure Marketing v2 to send your email messages, then normal LuxSci click and open reporting is disabled (and you will not see click and open data in this report). The LuxSci Secure Marketing v2 platform his its own click and open tracking and reporting system and you should look in that interface for reports.*  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#open).  Dates, for the purposes of narrowing results, refer to the date the message was sent. This corresponds to the “date_sent” output field. However, if you set the “open_date” input parameter to true, then the “open_date” field will be used for date selections.  {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_open_report_user_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled and which have been opened at least once. When opened is positive, you will get one row back for each open; so, <i>you can get multiple rows per message</i>.<br><br>If you do not specify a value for “opened”, a value of “1” will be assumed.
        :param bool open_date: If true, the ”open_date” field will be used for all date selections. If false or not specified, the sent date (“date_sent”) will be used.
        :param str sendmail_id: Return only the messages with the specified sendmail_id.
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param str status: Values:<br><b>delivered</b> – Accepted by the recipient’s email servers and presumed delivered. If bounce processing is enabled, then this status could change later to ba_soft_fail or ba_hard_fail.<br><b>perm_fail</b> – Messages that have permanently failed to be delivered to the recipient’s servers. If bounce processing is on, this status could change shortly to ba_soft_fail, depending on the nature of the failure message.<br><b>lost</b> – Messages where the tracking was lost and it is unclear if it was delivered or lost from the queue.<br><b>queued</b> – Message is in the email server queue still waiting to be delivered to the recipient.<br><b>not_queued</b> -- all statuses except \"queued\". <br><b>ba_soft_fail</b> – Soft failure bounces received (when talking to the recipient’s servers or after successful delivery to the recipient’s servers).<br><b>ba_hard_fail</b> – Hard failure bounces received after successful delivery to the recipient’s servers,<br><b>any_hard_fail</b> – Results for ba_hard_fail OR perm_fail. I.e., all hard/permanent failures.
        :param str subject: Case-insensitive substring search of the message subject (in UTF8).
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param int template_id: Optional template ID to select results only for those messages sent using the specified template.  A value of 0 selects all.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', '_from', 'header1', 'header1_operator', 'header1_value', 'header2', 'header2_operator', 'header2_value', 'header3', 'header3_operator', 'header3_value', 'opened', 'open_date', 'sendmail_id', 'sendmail_ids', 'status', 'subject', 'to', 'tracked_headers', 'template_id', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_email_smtp_open_report_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_email_smtp_open_report_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'header1' in params:
            query_params.append(('header1', params['header1']))  # noqa: E501
        if 'header1_operator' in params:
            query_params.append(('header1_operator', params['header1_operator']))  # noqa: E501
        if 'header1_value' in params:
            query_params.append(('header1_value', params['header1_value']))  # noqa: E501
        if 'header2' in params:
            query_params.append(('header2', params['header2']))  # noqa: E501
        if 'header2_operator' in params:
            query_params.append(('header2_operator', params['header2_operator']))  # noqa: E501
        if 'header2_value' in params:
            query_params.append(('header2_value', params['header2_value']))  # noqa: E501
        if 'header3' in params:
            query_params.append(('header3', params['header3']))  # noqa: E501
        if 'header3_operator' in params:
            query_params.append(('header3_operator', params['header3_operator']))  # noqa: E501
        if 'header3_value' in params:
            query_params.append(('header3_value', params['header3_value']))  # noqa: E501
        if 'opened' in params:
            query_params.append(('opened', params['opened']))  # noqa: E501
        if 'open_date' in params:
            query_params.append(('open_date', params['open_date']))  # noqa: E501
        if 'sendmail_id' in params:
            query_params.append(('sendmail_id', params['sendmail_id']))  # noqa: E501
        if 'sendmail_ids' in params:
            query_params.append(('sendmail_ids', params['sendmail_ids']))  # noqa: E501
        if 'status' in params:
            query_params.append(('status', params['status']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'to' in params:
            query_params.append(('to', params['to']))  # noqa: E501
        if 'tracked_headers' in params:
            query_params.append(('tracked_headers', params['tracked_headers']))  # noqa: E501
        if 'template_id' in params:
            query_params.append(('template_id', params['template_id']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/report/email/smtp/opens', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_email_smtp_open_summary_report_user(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_open_summary_report_user  # noqa: E501

        This report allows returns the number of opens that happened in the selected time period.  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#opens_count). *Note: if you are using LuxSci Secure Marketing v2 to send your email messages, then normal LuxSci click and open reporting is disabled (and you will not see click and open data in this report). The LuxSci Secure Marketing v2 platform his its own click and open tracking and reporting system and you should look in that interface for reports.* Dates, for the purposes of narrowing results, refer to the date the message was opened.  {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_open_summary_report_user(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str filter1: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter2: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter3: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled and which have been opened at least once. When opened is positive, you will get one row back for each open; so, <i>you can get multiple rows per message</i>.<br><br>If you do not specify a value for “opened”, a value of “1” will be assumed.
        :param str subject: Case-insensitive substring search of the message subject (in UTF8).
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param int template_id: Optional template ID to select results only for those messages sent using the specified template.  A value of 0 selects all.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_email_smtp_open_summary_report_user_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_email_smtp_open_summary_report_user_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_email_smtp_open_summary_report_user_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_open_summary_report_user  # noqa: E501

        This report allows returns the number of opens that happened in the selected time period.  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#opens_count). *Note: if you are using LuxSci Secure Marketing v2 to send your email messages, then normal LuxSci click and open reporting is disabled (and you will not see click and open data in this report). The LuxSci Secure Marketing v2 platform his its own click and open tracking and reporting system and you should look in that interface for reports.* Dates, for the purposes of narrowing results, refer to the date the message was opened.  {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_open_summary_report_user_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str filter1: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter2: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter3: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled and which have been opened at least once. When opened is positive, you will get one row back for each open; so, <i>you can get multiple rows per message</i>.<br><br>If you do not specify a value for “opened”, a value of “1” will be assumed.
        :param str subject: Case-insensitive substring search of the message subject (in UTF8).
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param int template_id: Optional template ID to select results only for those messages sent using the specified template.  A value of 0 selects all.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', 'filter1', 'filter2', 'filter3', '_from', 'header1', 'header1_operator', 'header1_value', 'header2', 'header2_operator', 'header2_value', 'header3', 'header3_operator', 'header3_value', 'opened', 'subject', 'to', 'tracked_headers', 'template_id', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_email_smtp_open_summary_report_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_email_smtp_open_summary_report_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if 'filter1' in params:
            query_params.append(('filter1', params['filter1']))  # noqa: E501
        if 'filter2' in params:
            query_params.append(('filter2', params['filter2']))  # noqa: E501
        if 'filter3' in params:
            query_params.append(('filter3', params['filter3']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'header1' in params:
            query_params.append(('header1', params['header1']))  # noqa: E501
        if 'header1_operator' in params:
            query_params.append(('header1_operator', params['header1_operator']))  # noqa: E501
        if 'header1_value' in params:
            query_params.append(('header1_value', params['header1_value']))  # noqa: E501
        if 'header2' in params:
            query_params.append(('header2', params['header2']))  # noqa: E501
        if 'header2_operator' in params:
            query_params.append(('header2_operator', params['header2_operator']))  # noqa: E501
        if 'header2_value' in params:
            query_params.append(('header2_value', params['header2_value']))  # noqa: E501
        if 'header3' in params:
            query_params.append(('header3', params['header3']))  # noqa: E501
        if 'header3_operator' in params:
            query_params.append(('header3_operator', params['header3_operator']))  # noqa: E501
        if 'header3_value' in params:
            query_params.append(('header3_value', params['header3_value']))  # noqa: E501
        if 'opened' in params:
            query_params.append(('opened', params['opened']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'to' in params:
            query_params.append(('to', params['to']))  # noqa: E501
        if 'tracked_headers' in params:
            query_params.append(('tracked_headers', params['tracked_headers']))  # noqa: E501
        if 'template_id' in params:
            query_params.append(('template_id', params['template_id']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/report/email/smtp/opens_count', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_email_smtp_sent_report_user(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_sent_report_user  # noqa: E501

        Return a list of all email messages sent via SMTP by `username`. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sent). {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_sent_report_user(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param str ip: Case-insensitive substring search of the sender IP address (for SMTP reports only).
        :param str opt_out: Value:<br>0 – SecureLine Opt Out not used<br>-1 – SecureLine Opt Out use not recorded for some reason<br>1 – SecureLine Opt Out
        :param str secureline: Value:<br>any – Match anything<br>-1 – SecureLine usage not recorded for some reason<br>1 – SecureLine encryption was used<br>0 – SecureLine encryption was not used<br><br>If SecureLine was used, use the delivery status report to see more details.
        :param str sendmail_id: Return only the message with the specified sendmail_id.
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param str spam: Value:<br>0 – Message was not marked as spam by a recipient and returned in a Feed Back Loop<br>1 – Message was marked as spam by a recipient and returned in a Feed Back Loop
        :param str subject: Case-insensitive substring search of the message subject (in UTF-8).
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param int template_id: Optional template ID to select results only for those messages sent using the specified template.  A value of 0 selects all.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param str user_id: Restrict the report to the user with this specific User ID number.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_email_smtp_sent_report_user_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_email_smtp_sent_report_user_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_email_smtp_sent_report_user_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_email_smtp_sent_report_user  # noqa: E501

        Return a list of all email messages sent via SMTP by `username`. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sent). {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_smtp_sent_report_user_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param str ip: Case-insensitive substring search of the sender IP address (for SMTP reports only).
        :param str opt_out: Value:<br>0 – SecureLine Opt Out not used<br>-1 – SecureLine Opt Out use not recorded for some reason<br>1 – SecureLine Opt Out
        :param str secureline: Value:<br>any – Match anything<br>-1 – SecureLine usage not recorded for some reason<br>1 – SecureLine encryption was used<br>0 – SecureLine encryption was not used<br><br>If SecureLine was used, use the delivery status report to see more details.
        :param str sendmail_id: Return only the message with the specified sendmail_id.
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param str spam: Value:<br>0 – Message was not marked as spam by a recipient and returned in a Feed Back Loop<br>1 – Message was marked as spam by a recipient and returned in a Feed Back Loop
        :param str subject: Case-insensitive substring search of the message subject (in UTF-8).
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param int template_id: Optional template ID to select results only for those messages sent using the specified template.  A value of 0 selects all.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param str user_id: Restrict the report to the user with this specific User ID number.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', '_from', 'header1', 'header1_operator', 'header1_value', 'header2', 'header2_operator', 'header2_value', 'header3', 'header3_operator', 'header3_value', 'ip', 'opt_out', 'secureline', 'sendmail_id', 'sendmail_ids', 'spam', 'subject', 'to', 'template_id', 'tracked_headers', 'user_id', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_email_smtp_sent_report_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_email_smtp_sent_report_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'header1' in params:
            query_params.append(('header1', params['header1']))  # noqa: E501
        if 'header1_operator' in params:
            query_params.append(('header1_operator', params['header1_operator']))  # noqa: E501
        if 'header1_value' in params:
            query_params.append(('header1_value', params['header1_value']))  # noqa: E501
        if 'header2' in params:
            query_params.append(('header2', params['header2']))  # noqa: E501
        if 'header2_operator' in params:
            query_params.append(('header2_operator', params['header2_operator']))  # noqa: E501
        if 'header2_value' in params:
            query_params.append(('header2_value', params['header2_value']))  # noqa: E501
        if 'header3' in params:
            query_params.append(('header3', params['header3']))  # noqa: E501
        if 'header3_operator' in params:
            query_params.append(('header3_operator', params['header3_operator']))  # noqa: E501
        if 'header3_value' in params:
            query_params.append(('header3_value', params['header3_value']))  # noqa: E501
        if 'ip' in params:
            query_params.append(('ip', params['ip']))  # noqa: E501
        if 'opt_out' in params:
            query_params.append(('opt_out', params['opt_out']))  # noqa: E501
        if 'secureline' in params:
            query_params.append(('secureline', params['secureline']))  # noqa: E501
        if 'sendmail_id' in params:
            query_params.append(('sendmail_id', params['sendmail_id']))  # noqa: E501
        if 'sendmail_ids' in params:
            query_params.append(('sendmail_ids', params['sendmail_ids']))  # noqa: E501
        if 'spam' in params:
            query_params.append(('spam', params['spam']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'to' in params:
            query_params.append(('to', params['to']))  # noqa: E501
        if 'template_id' in params:
            query_params.append(('template_id', params['template_id']))  # noqa: E501
        if 'tracked_headers' in params:
            query_params.append(('tracked_headers', params['tracked_headers']))  # noqa: E501
        if 'user_id' in params:
            query_params.append(('user_id', params['user_id']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/report/email/smtp/sent', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_email_web_mail_click_report_user(self, username, **kwargs):  # noqa: E501
        """get_email_web_mail_click_report_user  # noqa: E501

        This report allows you to query on the “URL click” events (or lack thereof) for Webmail email messages sent by `username` that have email click tracking enabled. Using this command, it is possible to get a report of all individual clicks or to get reports about messages that have not yet been clicked on or for which click tracking was not enabled. See the query parameters for more detail.  *Note: if you are using LuxSci Secure Marketing v2 to send your email messages, then normal LuxSci click and open reporting is disabled (and you will not see click and open data in this report). The LuxSci Secure Marketing v2 platform his its own click and open tracking and reporting system and you should look in that interface for reports.*  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#click).  Dates, for the purposes of narrowing results, refer to the date the message was sent. This corresponds to the `date_sent` output field. However, if you set the `click_date` input parameter to true, then the `click_date` field will be used for date selections.  {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_web_mail_click_report_user(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param int clicked: If specified, the results are restricted as follows:<br>clicked < 0 – select messages where click tracking was not enabled.<br>clicked = 0 – select messages where click tracking was enabled, but where no URLs have yet been clicked by the recipient.<br>clicked > 0 – select messages where one or more URLs have been clicked by the recipient. When “clicked” is positive, you will get one row back for each click; so,<i>you can get multiple rows per message</i>.<br><br>If a value for “clicked” is not specified, a value of “1” will be assumed.
        :param str click_date: If true, the ”click_date” field will be used for all date selections. If false or not specified, the sent date (“date_sent”) will be used.
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled, and which have been opened at least once. 
        :param str sendmail_id: String. Return only the messages with the specified sendmail_id
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param str status: Values:<br><b>delivered</b> – Accepted by the recipient’s email servers and presumed delivered. If bounce processing is enabled, then this status could change later to ba_soft_fail or ba_hard_fail.<br><b>perm_fail</b> – Messages that have permanently failed to be delivered to the recipient’s servers. If bounce processing is on, this status could change shortly to ba_soft_fail, depending on the nature of the failure message.<br><b>lost</b> – Messages where the tracking was lost and it is unclear if it was delivered or lost from the queue.<br><b>queued</b> – Message is in the email server queue still waiting to be delivered to the recipient.<br><b>not_queued</b> -- all statuses except \"queued\". <br><b>ba_soft_fail</b> – Soft failure bounces received (when talking to the recipient’s servers or after successful delivery to the recipient’s servers).<br><b>ba_hard_fail</b> – Hard failure bounces received after successful delivery to the recipient’s servers,<br><b>any_hard_fail</b> – Results for ba_hard_fail OR perm_fail. I.e., all hard/permanent failures.
        :param str subject: Case-insensitive substring search of the message subject (in UTF8).
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param str user_id: Restrict the report to the user with this specific User ID number
        :param str url: Substring match on the URL clicked.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_email_web_mail_click_report_user_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_email_web_mail_click_report_user_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_email_web_mail_click_report_user_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_email_web_mail_click_report_user  # noqa: E501

        This report allows you to query on the “URL click” events (or lack thereof) for Webmail email messages sent by `username` that have email click tracking enabled. Using this command, it is possible to get a report of all individual clicks or to get reports about messages that have not yet been clicked on or for which click tracking was not enabled. See the query parameters for more detail.  *Note: if you are using LuxSci Secure Marketing v2 to send your email messages, then normal LuxSci click and open reporting is disabled (and you will not see click and open data in this report). The LuxSci Secure Marketing v2 platform his its own click and open tracking and reporting system and you should look in that interface for reports.*  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#click).  Dates, for the purposes of narrowing results, refer to the date the message was sent. This corresponds to the `date_sent` output field. However, if you set the `click_date` input parameter to true, then the `click_date` field will be used for date selections.  {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_web_mail_click_report_user_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param int clicked: If specified, the results are restricted as follows:<br>clicked < 0 – select messages where click tracking was not enabled.<br>clicked = 0 – select messages where click tracking was enabled, but where no URLs have yet been clicked by the recipient.<br>clicked > 0 – select messages where one or more URLs have been clicked by the recipient. When “clicked” is positive, you will get one row back for each click; so,<i>you can get multiple rows per message</i>.<br><br>If a value for “clicked” is not specified, a value of “1” will be assumed.
        :param str click_date: If true, the ”click_date” field will be used for all date selections. If false or not specified, the sent date (“date_sent”) will be used.
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled, and which have been opened at least once. 
        :param str sendmail_id: String. Return only the messages with the specified sendmail_id
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param str status: Values:<br><b>delivered</b> – Accepted by the recipient’s email servers and presumed delivered. If bounce processing is enabled, then this status could change later to ba_soft_fail or ba_hard_fail.<br><b>perm_fail</b> – Messages that have permanently failed to be delivered to the recipient’s servers. If bounce processing is on, this status could change shortly to ba_soft_fail, depending on the nature of the failure message.<br><b>lost</b> – Messages where the tracking was lost and it is unclear if it was delivered or lost from the queue.<br><b>queued</b> – Message is in the email server queue still waiting to be delivered to the recipient.<br><b>not_queued</b> -- all statuses except \"queued\". <br><b>ba_soft_fail</b> – Soft failure bounces received (when talking to the recipient’s servers or after successful delivery to the recipient’s servers).<br><b>ba_hard_fail</b> – Hard failure bounces received after successful delivery to the recipient’s servers,<br><b>any_hard_fail</b> – Results for ba_hard_fail OR perm_fail. I.e., all hard/permanent failures.
        :param str subject: Case-insensitive substring search of the message subject (in UTF8).
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param str user_id: Restrict the report to the user with this specific User ID number
        :param str url: Substring match on the URL clicked.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', '_from', 'clicked', 'click_date', 'header1', 'header1_operator', 'header1_value', 'header2', 'header2_operator', 'header2_value', 'header3', 'header3_operator', 'header3_value', 'opened', 'sendmail_id', 'sendmail_ids', 'status', 'subject', 'to', 'tracked_headers', 'user_id', 'url', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_email_web_mail_click_report_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_email_web_mail_click_report_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'clicked' in params:
            query_params.append(('clicked', params['clicked']))  # noqa: E501
        if 'click_date' in params:
            query_params.append(('click_date', params['click_date']))  # noqa: E501
        if 'header1' in params:
            query_params.append(('header1', params['header1']))  # noqa: E501
        if 'header1_operator' in params:
            query_params.append(('header1_operator', params['header1_operator']))  # noqa: E501
        if 'header1_value' in params:
            query_params.append(('header1_value', params['header1_value']))  # noqa: E501
        if 'header2' in params:
            query_params.append(('header2', params['header2']))  # noqa: E501
        if 'header2_operator' in params:
            query_params.append(('header2_operator', params['header2_operator']))  # noqa: E501
        if 'header2_value' in params:
            query_params.append(('header2_value', params['header2_value']))  # noqa: E501
        if 'header3' in params:
            query_params.append(('header3', params['header3']))  # noqa: E501
        if 'header3_operator' in params:
            query_params.append(('header3_operator', params['header3_operator']))  # noqa: E501
        if 'header3_value' in params:
            query_params.append(('header3_value', params['header3_value']))  # noqa: E501
        if 'opened' in params:
            query_params.append(('opened', params['opened']))  # noqa: E501
        if 'sendmail_id' in params:
            query_params.append(('sendmail_id', params['sendmail_id']))  # noqa: E501
        if 'sendmail_ids' in params:
            query_params.append(('sendmail_ids', params['sendmail_ids']))  # noqa: E501
        if 'status' in params:
            query_params.append(('status', params['status']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'to' in params:
            query_params.append(('to', params['to']))  # noqa: E501
        if 'tracked_headers' in params:
            query_params.append(('tracked_headers', params['tracked_headers']))  # noqa: E501
        if 'user_id' in params:
            query_params.append(('user_id', params['user_id']))  # noqa: E501
        if 'url' in params:
            query_params.append(('url', params['url']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/report/email/webmail/clicks', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_email_web_mail_delivery_status_report_user(self, username, **kwargs):  # noqa: E501
        """get_email_web_mail_delivery_status_report_user  # noqa: E501

        This report allows you to see how each Webmail message sent by `username` was sent to each recipient and what the delivery status is for each of these recipients. Note that delivery status changes over time as messages progress to the recipient’s servers and as bounce messages are sent back and processed. As the delivery status changes, the “last_update” date is also updated.  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#delivery).  Dates, for the purposes of narrowing results, refer to the *date the message delivery status was last updated*. This corresponds to the `last_update` output field.  This can be changed to the date the message was sent using the \"sent_date\" parameter. {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_web_mail_delivery_status_report_user(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param int clicked: Integer. If specified, the results are restricted as follows:<br>clicked < 0 – select messages where URL click tracking was not enabled.<br>clicked = 0 – select messages where URL click tracking was enabled, but where there have as yet been no clicks on any clinks in the messages.<br>clicked > 0 – select messages where URL click tracking was enabled and where there have been N or more clicks on links in the same message to the same recipient. N, in this case, is the number that you have specified as the value of the “clicked” parameter. I.e., using a value of “1” matches all messages that have had a link clicked on.
        :param str _from: String. Case-insensitive substring search of the message “From” email Address
        :param str ip: String. Case-insensitive substring search of the sender IP address (for SMTP reports only).
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: Integer. If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled and which have been opened at least N times. N, in this case, is the number that you have specified as the value of the “opened” parameter. I.e., using a value of “1” matches all messages that have been opened.
        :param str secureline: Enum. Value:<br>u – Message to this recipient did not use SecureLine (or Opt Out was used)<br>e – Message did use SecureLine<br>-2 – SecureLine was not used due to Opt Out being selected<br>-1 – SecureLine usage not recorded for some reason<br>1 – SecureLine:PGP was used<br>2 – SecureLine:S/MIME was used<br>3 – SecureLine:Escrow was used<br>4 – SecureLine:TLS was used
        :param str sendmail_id: String. Return only the messages with the specified sendmail_id
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param int sent_date: If set to true (i.e., 1), the email message sent date will be used for date/time selections, instead of the date of the last update of the delivery status.
        :param int spam: Enum. Value:<br>0 – Message was not marked as spam by a recipient and returned in a Feed Back Loop.<br>1 – Message was marked as spam by a recipient and returned in a Feed Back Loop
        :param int tls: Enum. Value:<br>0 – TLS was NOT used in the successful delivery of this message to the recipient server<br>1 – TLS was used in the successful delivery of this message to the recipient server
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param int user_id: Integer. Restrict the report to the user with this specific User ID number
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_email_web_mail_delivery_status_report_user_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_email_web_mail_delivery_status_report_user_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_email_web_mail_delivery_status_report_user_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_email_web_mail_delivery_status_report_user  # noqa: E501

        This report allows you to see how each Webmail message sent by `username` was sent to each recipient and what the delivery status is for each of these recipients. Note that delivery status changes over time as messages progress to the recipient’s servers and as bounce messages are sent back and processed. As the delivery status changes, the “last_update” date is also updated.  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#delivery).  Dates, for the purposes of narrowing results, refer to the *date the message delivery status was last updated*. This corresponds to the `last_update` output field.  This can be changed to the date the message was sent using the \"sent_date\" parameter. {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_web_mail_delivery_status_report_user_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param int clicked: Integer. If specified, the results are restricted as follows:<br>clicked < 0 – select messages where URL click tracking was not enabled.<br>clicked = 0 – select messages where URL click tracking was enabled, but where there have as yet been no clicks on any clinks in the messages.<br>clicked > 0 – select messages where URL click tracking was enabled and where there have been N or more clicks on links in the same message to the same recipient. N, in this case, is the number that you have specified as the value of the “clicked” parameter. I.e., using a value of “1” matches all messages that have had a link clicked on.
        :param str _from: String. Case-insensitive substring search of the message “From” email Address
        :param str ip: String. Case-insensitive substring search of the sender IP address (for SMTP reports only).
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: Integer. If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled and which have been opened at least N times. N, in this case, is the number that you have specified as the value of the “opened” parameter. I.e., using a value of “1” matches all messages that have been opened.
        :param str secureline: Enum. Value:<br>u – Message to this recipient did not use SecureLine (or Opt Out was used)<br>e – Message did use SecureLine<br>-2 – SecureLine was not used due to Opt Out being selected<br>-1 – SecureLine usage not recorded for some reason<br>1 – SecureLine:PGP was used<br>2 – SecureLine:S/MIME was used<br>3 – SecureLine:Escrow was used<br>4 – SecureLine:TLS was used
        :param str sendmail_id: String. Return only the messages with the specified sendmail_id
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param int sent_date: If set to true (i.e., 1), the email message sent date will be used for date/time selections, instead of the date of the last update of the delivery status.
        :param int spam: Enum. Value:<br>0 – Message was not marked as spam by a recipient and returned in a Feed Back Loop.<br>1 – Message was marked as spam by a recipient and returned in a Feed Back Loop
        :param int tls: Enum. Value:<br>0 – TLS was NOT used in the successful delivery of this message to the recipient server<br>1 – TLS was used in the successful delivery of this message to the recipient server
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param int user_id: Integer. Restrict the report to the user with this specific User ID number
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', 'clicked', '_from', 'ip', 'header1', 'header1_operator', 'header1_value', 'header2', 'header2_operator', 'header2_value', 'header3', 'header3_operator', 'header3_value', 'opened', 'secureline', 'sendmail_id', 'sendmail_ids', 'sent_date', 'spam', 'tls', 'tracked_headers', 'to', 'user_id', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_email_web_mail_delivery_status_report_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_email_web_mail_delivery_status_report_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if 'clicked' in params:
            query_params.append(('clicked', params['clicked']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'ip' in params:
            query_params.append(('ip', params['ip']))  # noqa: E501
        if 'header1' in params:
            query_params.append(('header1', params['header1']))  # noqa: E501
        if 'header1_operator' in params:
            query_params.append(('header1_operator', params['header1_operator']))  # noqa: E501
        if 'header1_value' in params:
            query_params.append(('header1_value', params['header1_value']))  # noqa: E501
        if 'header2' in params:
            query_params.append(('header2', params['header2']))  # noqa: E501
        if 'header2_operator' in params:
            query_params.append(('header2_operator', params['header2_operator']))  # noqa: E501
        if 'header2_value' in params:
            query_params.append(('header2_value', params['header2_value']))  # noqa: E501
        if 'header3' in params:
            query_params.append(('header3', params['header3']))  # noqa: E501
        if 'header3_operator' in params:
            query_params.append(('header3_operator', params['header3_operator']))  # noqa: E501
        if 'header3_value' in params:
            query_params.append(('header3_value', params['header3_value']))  # noqa: E501
        if 'opened' in params:
            query_params.append(('opened', params['opened']))  # noqa: E501
        if 'secureline' in params:
            query_params.append(('secureline', params['secureline']))  # noqa: E501
        if 'sendmail_id' in params:
            query_params.append(('sendmail_id', params['sendmail_id']))  # noqa: E501
        if 'sendmail_ids' in params:
            query_params.append(('sendmail_ids', params['sendmail_ids']))  # noqa: E501
        if 'sent_date' in params:
            query_params.append(('sent_date', params['sent_date']))  # noqa: E501
        if 'spam' in params:
            query_params.append(('spam', params['spam']))  # noqa: E501
        if 'tls' in params:
            query_params.append(('tls', params['tls']))  # noqa: E501
        if 'tracked_headers' in params:
            query_params.append(('tracked_headers', params['tracked_headers']))  # noqa: E501
        if 'to' in params:
            query_params.append(('to', params['to']))  # noqa: E501
        if 'user_id' in params:
            query_params.append(('user_id', params['user_id']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/report/email/webmail/delivery', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_email_web_mail_open_report_user(self, username, **kwargs):  # noqa: E501
        """get_email_web_mail_open_report_user  # noqa: E501

        This report allows you to query on the “opened” events (or lack thereof) for email messages sent via Webmail by `username` that have email open tracking enabled. Using this command, it is possible to get a report of all individual opens for messages or to get reports about messages that have not yet been opened or for which open tracking was not enabled. See the query parameters for more detail.  *Note: if you are using LuxSci Secure Marketing v2 to send your email messages, then normal LuxSci click and open reporting is disabled (and you will not see click and open data in this report). The LuxSci Secure Marketing v2 platform his its own click and open tracking and reporting system and you should look in that interface for reports.*  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#open).  Dates, for the purposes of narrowing results, refer to the date the message was sent. This corresponds to the `date_sent` output field. However, if you set the `open_date` input parameter to true, then the `open_date` field will be used for date selections.  {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_web_mail_open_report_user(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled and which have been opened at least once. When opened is positive, you will get one row back for each open; so, <i>you can get multiple rows per message</i>.<br><br>If you do not specify a value for “opened”, a value of “1” will be assumed.
        :param bool open_date: If true, the ”open_date” field will be used for all date selections. If false or not specified, the sent date (“date_sent”) will be used.
        :param str sendmail_id: Return only the messages with the specified sendmail_id.
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param str status: Values:<br><b>delivered</b> – Accepted by the recipient’s email servers and presumed delivered. If bounce processing is enabled, then this status could change later to ba_soft_fail or ba_hard_fail.<br><b>perm_fail</b> – Messages that have permanently failed to be delivered to the recipient’s servers. If bounce processing is on, this status could change shortly to ba_soft_fail, depending on the nature of the failure message.<br><b>lost</b> – Messages where the tracking was lost and it is unclear if it was delivered or lost from the queue.<br><b>queued</b> – Message is in the email server queue still waiting to be delivered to the recipient.<br><b>not_queued</b> -- all statuses except \"queued\". <br><b>ba_soft_fail</b> – Soft failure bounces received (when talking to the recipient’s servers or after successful delivery to the recipient’s servers).<br><b>ba_hard_fail</b> – Hard failure bounces received after successful delivery to the recipient’s servers,<br><b>any_hard_fail</b> – Results for ba_hard_fail OR perm_fail. I.e., all hard/permanent failures.
        :param str subject: Case-insensitive substring search of the message subject (in UTF8).
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param str user_id: Restrict the report to the user with this specific User ID number
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_email_web_mail_open_report_user_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_email_web_mail_open_report_user_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_email_web_mail_open_report_user_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_email_web_mail_open_report_user  # noqa: E501

        This report allows you to query on the “opened” events (or lack thereof) for email messages sent via Webmail by `username` that have email open tracking enabled. Using this command, it is possible to get a report of all individual opens for messages or to get reports about messages that have not yet been opened or for which open tracking was not enabled. See the query parameters for more detail.  *Note: if you are using LuxSci Secure Marketing v2 to send your email messages, then normal LuxSci click and open reporting is disabled (and you will not see click and open data in this report). The LuxSci Secure Marketing v2 platform his its own click and open tracking and reporting system and you should look in that interface for reports.*  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#open).  Dates, for the purposes of narrowing results, refer to the date the message was sent. This corresponds to the `date_sent` output field. However, if you set the `open_date` input parameter to true, then the `open_date` field will be used for date selections.  {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_web_mail_open_report_user_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param int opened: If specified, the results are restricted as follows:<br>opened < 0 – select messages where open tracking was not enabled.<br>opened = 0 – select messages where open tracking was enabled, but which have not yet been opened.<br>opened > 0 – select messages where open tracking was enabled and which have been opened at least once. When opened is positive, you will get one row back for each open; so, <i>you can get multiple rows per message</i>.<br><br>If you do not specify a value for “opened”, a value of “1” will be assumed.
        :param bool open_date: If true, the ”open_date” field will be used for all date selections. If false or not specified, the sent date (“date_sent”) will be used.
        :param str sendmail_id: Return only the messages with the specified sendmail_id.
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param str status: Values:<br><b>delivered</b> – Accepted by the recipient’s email servers and presumed delivered. If bounce processing is enabled, then this status could change later to ba_soft_fail or ba_hard_fail.<br><b>perm_fail</b> – Messages that have permanently failed to be delivered to the recipient’s servers. If bounce processing is on, this status could change shortly to ba_soft_fail, depending on the nature of the failure message.<br><b>lost</b> – Messages where the tracking was lost and it is unclear if it was delivered or lost from the queue.<br><b>queued</b> – Message is in the email server queue still waiting to be delivered to the recipient.<br><b>not_queued</b> -- all statuses except \"queued\". <br><b>ba_soft_fail</b> – Soft failure bounces received (when talking to the recipient’s servers or after successful delivery to the recipient’s servers).<br><b>ba_hard_fail</b> – Hard failure bounces received after successful delivery to the recipient’s servers,<br><b>any_hard_fail</b> – Results for ba_hard_fail OR perm_fail. I.e., all hard/permanent failures.
        :param str subject: Case-insensitive substring search of the message subject (in UTF8).
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param str user_id: Restrict the report to the user with this specific User ID number
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', '_from', 'header1', 'header1_operator', 'header1_value', 'header2', 'header2_operator', 'header2_value', 'header3', 'header3_operator', 'header3_value', 'opened', 'open_date', 'sendmail_id', 'sendmail_ids', 'status', 'subject', 'to', 'tracked_headers', 'user_id', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_email_web_mail_open_report_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_email_web_mail_open_report_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'header1' in params:
            query_params.append(('header1', params['header1']))  # noqa: E501
        if 'header1_operator' in params:
            query_params.append(('header1_operator', params['header1_operator']))  # noqa: E501
        if 'header1_value' in params:
            query_params.append(('header1_value', params['header1_value']))  # noqa: E501
        if 'header2' in params:
            query_params.append(('header2', params['header2']))  # noqa: E501
        if 'header2_operator' in params:
            query_params.append(('header2_operator', params['header2_operator']))  # noqa: E501
        if 'header2_value' in params:
            query_params.append(('header2_value', params['header2_value']))  # noqa: E501
        if 'header3' in params:
            query_params.append(('header3', params['header3']))  # noqa: E501
        if 'header3_operator' in params:
            query_params.append(('header3_operator', params['header3_operator']))  # noqa: E501
        if 'header3_value' in params:
            query_params.append(('header3_value', params['header3_value']))  # noqa: E501
        if 'opened' in params:
            query_params.append(('opened', params['opened']))  # noqa: E501
        if 'open_date' in params:
            query_params.append(('open_date', params['open_date']))  # noqa: E501
        if 'sendmail_id' in params:
            query_params.append(('sendmail_id', params['sendmail_id']))  # noqa: E501
        if 'sendmail_ids' in params:
            query_params.append(('sendmail_ids', params['sendmail_ids']))  # noqa: E501
        if 'status' in params:
            query_params.append(('status', params['status']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'to' in params:
            query_params.append(('to', params['to']))  # noqa: E501
        if 'tracked_headers' in params:
            query_params.append(('tracked_headers', params['tracked_headers']))  # noqa: E501
        if 'user_id' in params:
            query_params.append(('user_id', params['user_id']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/report/email/webmail/opens', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_email_web_mail_sent_report_user(self, username, **kwargs):  # noqa: E501
        """get_email_web_mail_sent_report_user  # noqa: E501

        Return a list of all email messages sent via Webmail by `username`.  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#sent). {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_web_mail_sent_report_user(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param str ip: Case-insensitive substring search of the sender IP address (for SMTP reports only).
        :param str opt_out: Value:<br>0 – SecureLine Opt Out not used<br>-1 – SecureLine Opt Out use not recorded for some reason<br>1 – SecureLine Opt Out
        :param str secureline: Value:<br>any – Match anything<br>-1 – SecureLine usage not recorded for some reason<br>1 – SecureLine encryption was used<br>0 – SecureLine encryption was not used<br><br>If SecureLine was used, use the delivery status report to see more details.
        :param str sendmail_id: Return only the message with the specified sendmail_id.
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param str spam: Value:<br>0 – Message was not marked as spam by a recipient and returned in a Feed Back Loop<br>1 – Message was marked as spam by a recipient and returned in a Feed Back Loop
        :param str subject: Case-insensitive substring search of the message subject (in UTF-8).
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param str user_id: Restrict the report to the user with this specific User ID number.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_email_web_mail_sent_report_user_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_email_web_mail_sent_report_user_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_email_web_mail_sent_report_user_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_email_web_mail_sent_report_user  # noqa: E501

        Return a list of all email messages sent via Webmail by `username`.  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#sent). {{ACL: User: View Reports}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_email_web_mail_sent_report_user_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str _from: Case-insensitive substring search of the message “From” email address
        :param str header1: Case-insensitive name of the custom email header field to match against in the “header 1” column. I.e., if you were matching against “X-My-Header” and saving this in header 1, you would enter “X-My-Header” as the value here.<br><br>NOTE: Data is only stored in the customer header capturing fields/columns if you have explicitly enabled this feature in the “Account Administration > Email” area of the LuxSci user interface.
        :param str header1_operator: If this is present and one of the following 4 values, then the query will only return messages that included “header1” when “header1” was being tracked, and which also satisfy the follow the criteria:<ul> <li>is --- The value of the email header named “header1” in the send email must have been exactly the same as header1_value</li> <li>not – The value of the email header named “header1” in the send email must not be exactly the same as header1_value</li> <li>like – The value of the email header named “header1” in the send email must contain (case insensitive) the value in header1_value</li> <li>notlike – The value of the email header named “header1” in the send email must not contain (case insensitive) the value in header1_value</li></ul>I.e., if you configured your account to capture the value of the header “X-My-Header” and saving this in “header column 1” and an email was sent with the header “X-My-Header: gh6577hh-abc”. This would have been stored in the database. You could then find this message by passing to this API function:<ul><li>header1 = “X-My-Header”</li><li>header1_operator = “is”</li><li>header1_value = “gh6577hh-abc”</li></ul>Or by passing:<ul><li>header1 = “X-My-Header”,/li><li>header1_operator = “like”</li><li>header1_value = “abc”</li>
        :param str header1_value: Text used with “header1_operator” for matching the value of the email header specified in the “header1” parameter in the original sent message.
        :param str header2: Like “header1” but applies to searching the header 2 column.
        :param str header2_operator: Like “header1_operator” but applies to searching the header 2 column.
        :param str header2_value: Like “header1_value” but applies to searching the header 2 column.
        :param str header3: Like “header1” but applies to searching the header 3 column.
        :param str header3_operator: Like “header1_operator” but applies to searching the header 3 column.
        :param str header3_value: Like “header1_value” but applies to searching the header 2 column.
        :param str ip: Case-insensitive substring search of the sender IP address (for SMTP reports only).
        :param str opt_out: Value:<br>0 – SecureLine Opt Out not used<br>-1 – SecureLine Opt Out use not recorded for some reason<br>1 – SecureLine Opt Out
        :param str secureline: Value:<br>any – Match anything<br>-1 – SecureLine usage not recorded for some reason<br>1 – SecureLine encryption was used<br>0 – SecureLine encryption was not used<br><br>If SecureLine was used, use the delivery status report to see more details.
        :param str sendmail_id: Return only the message with the specified sendmail_id.
        :param str sendmail_ids: Comma-delimited list of up to 100 sendmail ids. Returns any matching messages.
        :param str spam: Value:<br>0 – Message was not marked as spam by a recipient and returned in a Feed Back Loop<br>1 – Message was marked as spam by a recipient and returned in a Feed Back Loop
        :param str subject: Case-insensitive substring search of the message subject (in UTF-8).
        :param str to: Case-insensitive substring search of all recipient email addresses.
        :param str tracked_headers: If true and this report is for messages sent vis SMTP, then the results will include the six additional fields (header1, header2, header3, header1_value, header2_value, header3_value) which are used to track custom email message header data.
        :param str user_id: Restrict the report to the user with this specific User ID number.
        :param str cookie:
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', '_from', 'header1', 'header1_operator', 'header1_value', 'header2', 'header2_operator', 'header2_value', 'header3', 'header3_operator', 'header3_value', 'ip', 'opt_out', 'secureline', 'sendmail_id', 'sendmail_ids', 'spam', 'subject', 'to', 'tracked_headers', 'user_id', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_email_web_mail_sent_report_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_email_web_mail_sent_report_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if '_from' in params:
            query_params.append(('from', params['_from']))  # noqa: E501
        if 'header1' in params:
            query_params.append(('header1', params['header1']))  # noqa: E501
        if 'header1_operator' in params:
            query_params.append(('header1_operator', params['header1_operator']))  # noqa: E501
        if 'header1_value' in params:
            query_params.append(('header1_value', params['header1_value']))  # noqa: E501
        if 'header2' in params:
            query_params.append(('header2', params['header2']))  # noqa: E501
        if 'header2_operator' in params:
            query_params.append(('header2_operator', params['header2_operator']))  # noqa: E501
        if 'header2_value' in params:
            query_params.append(('header2_value', params['header2_value']))  # noqa: E501
        if 'header3' in params:
            query_params.append(('header3', params['header3']))  # noqa: E501
        if 'header3_operator' in params:
            query_params.append(('header3_operator', params['header3_operator']))  # noqa: E501
        if 'header3_value' in params:
            query_params.append(('header3_value', params['header3_value']))  # noqa: E501
        if 'ip' in params:
            query_params.append(('ip', params['ip']))  # noqa: E501
        if 'opt_out' in params:
            query_params.append(('opt_out', params['opt_out']))  # noqa: E501
        if 'secureline' in params:
            query_params.append(('secureline', params['secureline']))  # noqa: E501
        if 'sendmail_id' in params:
            query_params.append(('sendmail_id', params['sendmail_id']))  # noqa: E501
        if 'sendmail_ids' in params:
            query_params.append(('sendmail_ids', params['sendmail_ids']))  # noqa: E501
        if 'spam' in params:
            query_params.append(('spam', params['spam']))  # noqa: E501
        if 'subject' in params:
            query_params.append(('subject', params['subject']))  # noqa: E501
        if 'to' in params:
            query_params.append(('to', params['to']))  # noqa: E501
        if 'tracked_headers' in params:
            query_params.append(('tracked_headers', params['tracked_headers']))  # noqa: E501
        if 'user_id' in params:
            query_params.append(('user_id', params['user_id']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/report/email/webmail/sent', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user_job(self, username, job_id, **kwargs):  # noqa: E501
        """get_user_job  # noqa: E501

        Return the details of a specific asynchronous reporting job. If the job_id is not found, a not found API error will be emitted.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_job(username, job_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param int job_id: (required)
        :param str cookie:
        :return: InlineResponse20033
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_job_with_http_info(username, job_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_user_job_with_http_info(username, job_id, **kwargs)  # noqa: E501
            return data

    def get_user_job_with_http_info(self, username, job_id, **kwargs):  # noqa: E501
        """get_user_job  # noqa: E501

        Return the details of a specific asynchronous reporting job. If the job_id is not found, a not found API error will be emitted.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_job_with_http_info(username, job_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param int job_id: (required)
        :param str cookie:
        :return: InlineResponse20033
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'job_id', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_job" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_user_job`")  # noqa: E501
        # verify the required parameter 'job_id' is set
        if ('job_id' not in params or
                params['job_id'] is None):
            raise ValueError("Missing the required parameter `job_id` when calling `get_user_job`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501
        if 'job_id' in params:
            path_params['job_id'] = params['job_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/job/{job_id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20033',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user_jobs(self, username, **kwargs):  # noqa: E501
        """get_user_jobs  # noqa: E501

        Return a list of all asynchronous reporting jobs submitted by this user in the past 7 days.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_jobs(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str cookie:
        :return: InlineResponse20032
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_jobs_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_user_jobs_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_user_jobs_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_user_jobs  # noqa: E501

        Return a list of all asynchronous reporting jobs submitted by this user in the past 7 days.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_jobs_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str cookie:
        :return: InlineResponse20032
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'cookie']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_jobs" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_user_jobs`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/jobs', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20032',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user_suppression_report(self, username, **kwargs):  # noqa: E501
        """get_user_suppression_report  # noqa: E501

        Retrieve all email suppressions at the user level using a report-style call.  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#sup). {{ACL: User Email: Suppression}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_suppression_report(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str cookie:
        :param str email: Restrict the report to suppressions of this specific email address.
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_suppression_report_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_user_suppression_report_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_user_suppression_report_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_user_suppression_report  # noqa: E501

        Retrieve all email suppressions at the user level using a report-style call.  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#sup). {{ACL: User Email: Suppression}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_suppression_report_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str cookie:
        :param str email: Restrict the report to suppressions of this specific email address.
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'cookie', 'email', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_suppression_report" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_user_suppression_report`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'email' in params:
            query_params.append(('email', params['email']))  # noqa: E501
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/suppression_v2/', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user_suppression_summary_report(self, username, **kwargs):  # noqa: E501
        """get_user_suppression_summary_report  # noqa: E501

        Retrieve a count of the matching email suppressions at the user level using a report-style call.  Dates are based on the date that the suppression was added.  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#sup_count). {{ACL: User Email: Suppression}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_suppression_summary_report(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str cookie:
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str filter1: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter2: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter3: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_suppression_summary_report_with_http_info(username, **kwargs)  # noqa: E501
        else:
            (data) = self.get_user_suppression_summary_report_with_http_info(username, **kwargs)  # noqa: E501
            return data

    def get_user_suppression_summary_report_with_http_info(self, username, **kwargs):  # noqa: E501
        """get_user_suppression_summary_report  # noqa: E501

        Retrieve a count of the matching email suppressions at the user level using a report-style call.  Dates are based on the date that the suppression was added.  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response](/rest-api/report-responses.html#sup_count). {{ACL: User Email: Suppression}}  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_suppression_summary_report_with_http_info(username, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str username: (required)
        :param str cookie:
        :param str after_date: DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
        :param str before_date: DATETIME. Return only matches dated before this date time.
        :param int first_row: (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
        :param str from_date: DATETIME. Return only matches dated on or after this date time.
        :param int matches: (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
        :param str through_date: DATETIME. Return only matches dated before or on this date time.
        :param str destination: For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
        :param str destination_directory: For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
        :param str destination_hostname: For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
        :param str destination_password: For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str destination_username: For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
        :param str filter1: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter2: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :param str filter3: Control when a summary report returns values (for use with automated reports). See https://luxsci.com/rest-api/reporting.html#filters
        :return: InlineResponse20021
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['username', 'cookie', 'after_date', 'before_date', 'first_row', 'from_date', 'matches', 'through_date', 'destination', 'destination_directory', 'destination_hostname', 'destination_password', 'destination_username', 'filter1', 'filter2', 'filter3']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user_suppression_summary_report" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'username' is set
        if ('username' not in params or
                params['username'] is None):
            raise ValueError("Missing the required parameter `username` when calling `get_user_suppression_summary_report`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'username' in params:
            path_params['username'] = params['username']  # noqa: E501

        query_params = []
        if 'after_date' in params:
            query_params.append(('after_date', params['after_date']))  # noqa: E501
        if 'before_date' in params:
            query_params.append(('before_date', params['before_date']))  # noqa: E501
        if 'first_row' in params:
            query_params.append(('first_row', params['first_row']))  # noqa: E501
        if 'from_date' in params:
            query_params.append(('from_date', params['from_date']))  # noqa: E501
        if 'matches' in params:
            query_params.append(('matches', params['matches']))  # noqa: E501
        if 'through_date' in params:
            query_params.append(('through_date', params['through_date']))  # noqa: E501
        if 'destination' in params:
            query_params.append(('destination', params['destination']))  # noqa: E501
        if 'destination_directory' in params:
            query_params.append(('destination_directory', params['destination_directory']))  # noqa: E501
        if 'destination_hostname' in params:
            query_params.append(('destination_hostname', params['destination_hostname']))  # noqa: E501
        if 'destination_password' in params:
            query_params.append(('destination_password', params['destination_password']))  # noqa: E501
        if 'destination_username' in params:
            query_params.append(('destination_username', params['destination_username']))  # noqa: E501
        if 'filter1' in params:
            query_params.append(('filter1', params['filter1']))  # noqa: E501
        if 'filter2' in params:
            query_params.append(('filter2', params['filter2']))  # noqa: E501
        if 'filter3' in params:
            query_params.append(('filter3', params['filter3']))  # noqa: E501

        header_params = {}
        if 'cookie' in params:
            header_params['Cookie'] = params['cookie']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/user/{username}/suppression_count/', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20021',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
